/*
 * MapEdit.java
 * Verze APPLET
 * Created on 12. 3. 2003, by Martin Cadik
 * cadikm@cs.felk.cvut.cz
 */

import java.io.*;

import dilewa.*;
import dilewa.event.*;
import dilewa.common.*;
import dilewa.client.*;

/**
 *
 * @author  Martin Cadik
 * @version 1.0
 */
public class MapEdit extends javax.swing.JApplet implements // Dilewa interfaces
  DErrorListener, DUserListener, DVariableListener, DVariableLockListener {
    public static final int MAX_FLOORS=10;
    public static final int APP_SIZE_X=900; //width of the window when stand-alone
    public static final int APP_SIZE_Y=700; //heigt of the window when stand-alone
    private static boolean standAlone=false;
    
    /** Creates new form MapEdit */
    public MapEdit() {
        initComponents ();
        textAreaOutput.append("MapEdit started!\n");
    }
  
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the FormEditor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        if(!standAlone) editPanel[0]=new EditPanel(this,0);
        newFloorPanel=new NewFloorPanel(this);
        removeFloorPanel=new RemoveFloorPanel(this);
        menuPanel = new javax.swing.JPanel();
        positionPanel = new javax.swing.JPanel();
        textFieldX = new javax.swing.JTextField();
        textFieldY = new javax.swing.JTextField();
        textFieldX1 = new javax.swing.JTextField();
        textFieldY1 = new javax.swing.JTextField();
        textFieldX2 = new javax.swing.JTextField();
        textFieldY2 = new javax.swing.JTextField();
        labelActual = new javax.swing.JLabel();
        labelComponents = new javax.swing.JLabel();
        labelX = new javax.swing.JLabel();
        labelY = new javax.swing.JLabel();
        labelX1 = new javax.swing.JLabel();
        labelY1 = new javax.swing.JLabel();
        labelX2 = new javax.swing.JLabel();
        labelY2 = new javax.swing.JLabel();
        settingsPanel = new javax.swing.JPanel();
        checkBoxEdit = new javax.swing.JCheckBox();
        checkBoxGrid = new javax.swing.JCheckBox();
        wallsPanel = new javax.swing.JPanel();
        radioButtonWallOuter = new javax.swing.JRadioButton();
        radioButtonWallArc = new javax.swing.JRadioButton();
        radioButtonWallInner = new javax.swing.JRadioButton();
        labelLength = new javax.swing.JLabel();
        textFieldWallLength = new javax.swing.JTextField();
        labelWidth = new javax.swing.JLabel();
        comboBoxWallType = new javax.swing.JComboBox(outerWalls);
        comboBoxWallWidths.put(new Integer(75), new Integer(0));
        comboBoxWallWidths.put(new Integer(220), new Integer(0));
        comboBoxWallWidths.put(new Integer(270), new Integer(0));
        comboBoxWallWidths.put(new Integer(600), new Integer(0));
        comboBoxWallWidths.put(new Integer(300), new Integer(1));
        comboBoxWallWidths.put(new Integer(700), new Integer(1));
        comboBoxWallWidths.put(new Integer(320), new Integer(2));
        comboBoxWallWidths.put(new Integer(800), new Integer(2));
        comboBoxWallWidths.put(new Integer(900), new Integer(3));
        comboBoxWallWidths.put(new Integer(1000), new Integer(3));
        comboBoxWallWidths.put(new Integer(1200), new Integer(4));
        comboBoxWallWidths.put(new Integer(1400), new Integer(5));
        comboBoxWallWidths.put(new Integer(1600), new Integer(6));
        radioButtonBridge = new javax.swing.JRadioButton();
        radioButtonText = new javax.swing.JRadioButton();
        javax.swing.ButtonGroup buttonGroup=new javax.swing.ButtonGroup();
        buttonGroup.add(radioButtonWallOuter);
        buttonGroup.add(radioButtonWallArc);
        buttonGroup.add(radioButtonWallInner);
        buttonGroup.add(radioButtonText);
        buttonGroup.add(radioButtonBridge);

        textFieldText = new javax.swing.JTextField();
        scrollPaneOutput = new javax.swing.JScrollPane();
        textAreaOutput = new javax.swing.JTextArea();
        tabbedPaneFloors = new javax.swing.JTabbedPane();
        tabbedPaneFloors.addTab("Pidat vrstvu", null, newFloorPanel, "Pidat dal vrstvu");
        tabbedPaneFloors.addTab("Odebrat vrstvu", null, removeFloorPanel, "Odebrat existujc vrstvu");
        if(!standAlone) {
            tabbedPaneFloors.addTab("0. vrstva", null, editPanel[0], "Zobrazen 0. vrstvy");
            tabbedPaneFloors.setSelectedIndex(2);
            numFloors=1;
        }
        else {
            tabbedPaneFloors.setSelectedIndex(1);
            numFloors=0;
        }

        topRulerPanel = new javax.swing.JPanel();
        leftRulerPanel = new javax.swing.JPanel();

        menuPanel.setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        positionPanel.setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        positionPanel.setBorder(new javax.swing.border.TitledBorder("Pozice"));
        textFieldX.setEditable(false);
        textFieldX.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        textFieldX.setText("0");
        textFieldX.setToolTipText("Aktu\u00e1ln\u00ed sou\u0159adnice X my\u0161i");
        positionPanel.add(textFieldX, new org.netbeans.lib.awtextra.AbsoluteConstraints(100, 20, 40, 20));

        textFieldY.setEditable(false);
        textFieldY.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        textFieldY.setText("0");
        textFieldY.setToolTipText("Aktu\u00e1ln\u00ed sou\u0159adnice Y my\u0161i");
        positionPanel.add(textFieldY, new org.netbeans.lib.awtextra.AbsoluteConstraints(170, 20, 40, 20));

        textFieldX1.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        textFieldX1.setText("0");
        textFieldX1.setToolTipText("Sou\u0159adnice X po\u010d\u00e1te\u010dn\u00edho bodu");
        positionPanel.add(textFieldX1, new org.netbeans.lib.awtextra.AbsoluteConstraints(100, 40, 40, 20));

        textFieldY1.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        textFieldY1.setText("0");
        textFieldY1.setToolTipText("Sou\u0159adnice Y po\u010d\u00e1te\u010dn\u00edho bodu");
        positionPanel.add(textFieldY1, new org.netbeans.lib.awtextra.AbsoluteConstraints(170, 40, 40, 20));

        textFieldX2.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        textFieldX2.setText("0");
        textFieldX2.setToolTipText("Sou\u0159adnice X koncov\u00e9ho bodu");
        positionPanel.add(textFieldX2, new org.netbeans.lib.awtextra.AbsoluteConstraints(100, 60, 40, 20));

        textFieldY2.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        textFieldY2.setText("0");
        textFieldY2.setToolTipText("Sou\u0159adnice Y koncov\u00e9ho bodu");
        positionPanel.add(textFieldY2, new org.netbeans.lib.awtextra.AbsoluteConstraints(170, 60, 40, 20));

        labelActual.setText("Aktu\u00e1ln\u00ed");
        positionPanel.add(labelActual, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 20, 60, 20));

        labelComponents.setText("Prvek");
        positionPanel.add(labelComponents, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 40, 60, 20));

        labelX.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        labelX.setText("x: ");
        positionPanel.add(labelX, new org.netbeans.lib.awtextra.AbsoluteConstraints(70, 20, 30, 20));

        labelY.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        labelY.setText("y: ");
        positionPanel.add(labelY, new org.netbeans.lib.awtextra.AbsoluteConstraints(140, 20, 30, 20));

        labelX1.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        labelX1.setText("x1: ");
        positionPanel.add(labelX1, new org.netbeans.lib.awtextra.AbsoluteConstraints(70, 40, 30, 20));

        labelY1.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        labelY1.setText("y1: ");
        positionPanel.add(labelY1, new org.netbeans.lib.awtextra.AbsoluteConstraints(140, 40, 30, 20));

        labelX2.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        labelX2.setText("x2: ");
        positionPanel.add(labelX2, new org.netbeans.lib.awtextra.AbsoluteConstraints(70, 60, 30, 20));

        labelY2.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        labelY2.setText("y2: ");
        positionPanel.add(labelY2, new org.netbeans.lib.awtextra.AbsoluteConstraints(140, 60, 30, 20));

        menuPanel.add(positionPanel, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 0, 220, 90));

        settingsPanel.setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        settingsPanel.setBorder(new javax.swing.border.TitledBorder(null, "Nastaven\u00ed", javax.swing.border.TitledBorder.LEFT, javax.swing.border.TitledBorder.DEFAULT_POSITION));
        checkBoxEdit.setText("Editace");
        checkBoxEdit.setToolTipText("Re\u017eim editace / kreslen\u00ed");
        checkBoxEdit.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                checkBoxEditActionPerformed(evt);
            }
        });

        settingsPanel.add(checkBoxEdit, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 20, 80, 20));

        checkBoxGrid.setSelected(true);
        checkBoxGrid.setText("M\u0159\u00ed\u017eka");
        checkBoxGrid.setToolTipText("Zobraz\u00ed/schov\u00e1 m\u0159\u00ed\u017eku");
        checkBoxGrid.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                checkBoxGridActionPerformed(evt);
            }
        });

        settingsPanel.add(checkBoxGrid, new org.netbeans.lib.awtextra.AbsoluteConstraints(100, 20, 80, 20));

        menuPanel.add(settingsPanel, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 90, 220, 50));

        wallsPanel.setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        wallsPanel.setBorder(new javax.swing.border.TitledBorder("Komunikace a vodn\u00ed toky"));
        radioButtonWallOuter.setSelected(true);
        radioButtonWallOuter.setText("Silnice");
        radioButtonWallOuter.setToolTipText("Pozemn\u00ed komunikace");
        radioButtonWallOuter.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                radioButtonWallOuterActionPerformed(evt);
            }
        });

        wallsPanel.add(radioButtonWallOuter, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 20, 120, 20));

        radioButtonWallArc.setText("Silnice - oblouk");
        radioButtonWallArc.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                radioButtonWallArcActionPerformed(evt);
            }
        });

        wallsPanel.add(radioButtonWallArc, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 40, 120, 20));

        radioButtonWallInner.setText("Vodn\u00ed tok");
        radioButtonWallInner.setToolTipText("\u0158eka");
        radioButtonWallInner.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                radioButtonWallInnerActionPerformed(evt);
            }
        });

        wallsPanel.add(radioButtonWallInner, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 60, 120, 20));

        labelLength.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        labelLength.setText("D\u00e9lka: ");
        wallsPanel.add(labelLength, new org.netbeans.lib.awtextra.AbsoluteConstraints(110, 150, 60, 20));

        textFieldWallLength.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        textFieldWallLength.setText("0");
        textFieldWallLength.setToolTipText("D\u00e9lka vybran\u00e9ho prvku");
        wallsPanel.add(textFieldWallLength, new org.netbeans.lib.awtextra.AbsoluteConstraints(170, 150, 40, 20));

        labelWidth.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        labelWidth.setText("\u0160\u00ed\u0159ka: ");
        wallsPanel.add(labelWidth, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 150, 40, 20));

        comboBoxWallType.setMaximumRowCount(3);
        comboBoxWallType.setToolTipText("\u0160\u00ed\u0159ka vybran\u00e9ho prvku");
        comboBoxWallType.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                comboBoxWallTypeActionPerformed(evt);
            }
        });

        wallsPanel.add(comboBoxWallType, new org.netbeans.lib.awtextra.AbsoluteConstraints(50, 150, 60, 20));

        radioButtonBridge.setText("Most");
        radioButtonBridge.setToolTipText("Most");
        radioButtonBridge.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                radioButtonBridgeActionPerformed(evt);
            }
        });

        wallsPanel.add(radioButtonBridge, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 80, 80, 20));

        radioButtonText.setText("Text");
        radioButtonText.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                radioButtonTextActionPerformed(evt);
            }
        });

        wallsPanel.add(radioButtonText, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 100, 80, 20));

        textFieldText.setText("Horn\u00ed Lhota");
        textFieldText.setToolTipText("Zadejte text pro vlo\u017een\u00ed do p\u016fdorysu");
        textFieldText.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                textFieldTextActionPerformed(evt);
            }
        });

        wallsPanel.add(textFieldText, new org.netbeans.lib.awtextra.AbsoluteConstraints(90, 100, 120, 20));

        menuPanel.add(wallsPanel, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 140, 220, 190));

        textAreaOutput.setEditable(false);
        scrollPaneOutput.setViewportView(textAreaOutput);

        menuPanel.add(scrollPaneOutput, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 350, 220, 210));

        getContentPane().add(menuPanel, java.awt.BorderLayout.EAST);

        tabbedPaneFloors.setTabPlacement(javax.swing.JTabbedPane.BOTTOM);
        tabbedPaneFloors.setAutoscrolls(true);
        tabbedPaneFloors.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                tabbedPaneFloorsStateChanged(evt);
            }
        });

        getContentPane().add(tabbedPaneFloors, java.awt.BorderLayout.CENTER);

        topRulerPanel.setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        topRulerPanel.setBorder(new javax.swing.border.MatteBorder(new java.awt.Insets(13, 1, 1, 631), new javax.swing.ImageIcon(getClass().getResource("topRuler.gif"))));
        topRulerPanel.setMaximumSize(new java.awt.Dimension(32767, 13));
        topRulerPanel.setMinimumSize(new java.awt.Dimension(642, 13));
        topRulerPanel.setPreferredSize(new java.awt.Dimension(642, 13));
        getContentPane().add(topRulerPanel, java.awt.BorderLayout.NORTH);

        leftRulerPanel.setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        leftRulerPanel.setBorder(new javax.swing.border.MatteBorder(new java.awt.Insets(600, 1, 1, 12), new javax.swing.ImageIcon(getClass().getResource("leftRuler.gif"))));
        leftRulerPanel.setMaximumSize(new java.awt.Dimension(13, 32767));
        leftRulerPanel.setMinimumSize(new java.awt.Dimension(13, 611));
        leftRulerPanel.setPreferredSize(new java.awt.Dimension(13, 611));
        getContentPane().add(leftRulerPanel, java.awt.BorderLayout.WEST);

    }//GEN-END:initComponents

  private void checkBoxGridActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_checkBoxGridActionPerformed
    editPanel[activeEditPanel].repaint();
  }//GEN-LAST:event_checkBoxGridActionPerformed

  private void radioButtonWallOuterActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_radioButtonWallOuterActionPerformed
    comboBoxWallType.removeAllItems();
    for(int i=0; i<outerWalls.length; i++)
    comboBoxWallType.addItem(outerWalls[i]);

    ((EditPanel)editPanel[activeEditPanel]).wallType=Wall.WALL_ROAD;
    actWallType=Wall.WALL_ROAD;
    int i=((EditPanel)editPanel[activeEditPanel]).wallWidth;
    try{i=Integer.parseInt((String)comboBoxWallType.getSelectedItem());}
    catch(NumberFormatException e){/*System.out.println(e);*/};
    ((EditPanel)editPanel[activeEditPanel]).wallWidth=i;
    actWallWidth=i;

    /*System.out.println("Type: "+((EditPanel)editPanel[activeEditPanel]).wallType);
    System.out.println("Width: "+((EditPanel)editPanel[activeEditPanel]).wallWidth);
    */
  }//GEN-LAST:event_radioButtonWallOuterActionPerformed

  private void radioButtonWallInnerActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_radioButtonWallInnerActionPerformed
    comboBoxWallType.removeAllItems();
    for(int i=0; i<innerWalls.length; i++)
    comboBoxWallType.addItem(innerWalls[i]);

    ((EditPanel)editPanel[activeEditPanel]).wallType=Wall.WALL_RIVER;
    actWallType=Wall.WALL_RIVER;
    int i=((EditPanel)editPanel[activeEditPanel]).wallWidth;
    try{i=Integer.parseInt((String)comboBoxWallType.getSelectedItem());}
    catch(NumberFormatException e){/*System.out.println(e);*/};
    ((EditPanel)editPanel[activeEditPanel]).wallWidth=i;
    actWallWidth=i;

    /*System.out.println("Type: "+((EditPanel)editPanel[activeEditPanel]).wallType);
    System.out.println("Width: "+((EditPanel)editPanel[activeEditPanel]).wallWidth);
    */
  }//GEN-LAST:event_radioButtonWallInnerActionPerformed

  private void radioButtonBridgeActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_radioButtonBridgeActionPerformed
    comboBoxWallType.removeAllItems();
    for(int i=0; i<windows.length; i++)
    comboBoxWallType.addItem(windows[i]);

    ((EditPanel)editPanel[activeEditPanel]).wallType=Wall.WALL_BRIDGE;
    actWallType=Wall.WALL_BRIDGE;
    int i=((EditPanel)editPanel[activeEditPanel]).wallWidth;
    try{i=Integer.parseInt((String)comboBoxWallType.getSelectedItem());}
    catch(NumberFormatException e){/*System.out.println(e);*/};
    ((EditPanel)editPanel[activeEditPanel]).wallWidth=i;
    actWallWidth=i;

    /*System.out.println("Type: "+((EditPanel)editPanel[activeEditPanel]).wallType);
    System.out.println("Width: "+((EditPanel)editPanel[activeEditPanel]).wallWidth);
    */
  }//GEN-LAST:event_radioButtonBridgeActionPerformed

  private void checkBoxEditActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_checkBoxEditActionPerformed
    if(checkBoxEdit.isSelected()) {
        ((EditPanel)editPanel[activeEditPanel]).edit=true;
        actEdit=true;
    }
    else {
        ((EditPanel)editPanel[activeEditPanel]).edit=false;
        actEdit=false;
    }
    /*System.out.println("Edit: " +((EditPanel)editPanel[activeEditPanel]).edit);*/
  }//GEN-LAST:event_checkBoxEditActionPerformed

  private void radioButtonTextActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_radioButtonTextActionPerformed
    ((EditPanel)editPanel[activeEditPanel]).wallType=Text.TEXT;
    actWallType=Text.TEXT;
  }//GEN-LAST:event_radioButtonTextActionPerformed

  private void textFieldTextActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_textFieldTextActionPerformed
    radioButtonText.doClick();
  }//GEN-LAST:event_textFieldTextActionPerformed

  private void radioButtonWallArcActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_radioButtonWallArcActionPerformed
    comboBoxWallType.removeAllItems();
    for(int i=0; i<outerWalls.length; i++)
    comboBoxWallType.addItem(outerWalls[i]);

    ((EditPanel)editPanel[activeEditPanel]).wallType=Arc.OUTER_WALL_ARC;
    actWallType=Arc.OUTER_WALL_ARC;
    int i=((EditPanel)editPanel[activeEditPanel]).wallWidth;
    try{i=Integer.parseInt((String)comboBoxWallType.getSelectedItem());}
    catch(NumberFormatException e){/*System.out.println(e);*/};
    ((EditPanel)editPanel[activeEditPanel]).wallWidth=i;
    actWallWidth=i;

    /*System.out.println("Type: "+((EditPanel)editPanel[activeEditPanel]).wallType);
    System.out.println("Width: "+((EditPanel)editPanel[activeEditPanel]).wallWidth);
    */
  }//GEN-LAST:event_radioButtonWallArcActionPerformed

  private void tabbedPaneFloorsStateChanged (javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_tabbedPaneFloorsStateChanged
    int i=tabbedPaneFloors.getSelectedIndex();
    if(i>1) activeEditPanel=i-2;
    
    ((EditPanel)editPanel[activeEditPanel]).wallType=actWallType;
    ((EditPanel)editPanel[activeEditPanel]).wallWidth=actWallWidth;
    ((EditPanel)editPanel[activeEditPanel]).edit=actEdit;    
  }//GEN-LAST:event_tabbedPaneFloorsStateChanged

  private void comboBoxWallTypeActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_comboBoxWallTypeActionPerformed
    int i=((EditPanel)editPanel[activeEditPanel]).wallWidth;
    try{i=Integer.parseInt((String)comboBoxWallType.getSelectedItem());}
    catch(NumberFormatException e){/*System.out.println(e);*/};
    ((EditPanel)editPanel[activeEditPanel]).wallWidth=i;
    actWallWidth=i;
    //((EditPanel)editPanel[activeEditPanel]).updateSelected();

    /*System.out.println("Type: "+((EditPanel)editPanel[activeEditPanel]).wallType);
    System.out.println("Width: "+((EditPanel)editPanel[activeEditPanel]).wallWidth);
    */
  }//GEN-LAST:event_comboBoxWallTypeActionPerformed

  private void buttonCleanActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonCleanActionPerformed
    ((EditPanel)editPanel[activeEditPanel]).clean();
  }//GEN-LAST:event_buttonCleanActionPerformed

private void jTextField6ActionPerformed (java.awt.event.ActionEvent evt) {
    // Add your handling code here:
}

  /**
        Creates new floor - 4 use when loading from XML
  */
  public EditPanel newFloor () {
    int i=numFloors;
    EditPanel ep=null;
    if(i>=MAX_FLOORS) {
        System.err.println("Error: max. number of floors exceeded!");
        return(ep);
    }
    editPanel[i]=new EditPanel(this, i);  
    ep=(EditPanel)editPanel[i];
        
    tabbedPaneFloors.addTab(i+". vrstva", null, editPanel[i], "Zobrazen "+i+". vrstvy");
    tabbedPaneFloors.setSelectedIndex(i+2);   
    activeEditPanel=i;
    numFloors++;  
    return(ep);
  }//newFloor


    public void updateParametersWall(Wall w){
        switch(w.type){
            case Wall.WALL_ROAD: 
                radioButtonWallOuter.doClick();               
            break;
            case Wall.WALL_RIVER: 
                radioButtonWallInner.doClick();
            break;
            case Arc.OUTER_WALL_ARC: 
                radioButtonWallArc.doClick();
            break;
        }//switch        
        Integer n = (Integer)comboBoxWallWidths.get(new Integer(w.thickness));
        if (n != null) 
            comboBoxWallType.setSelectedIndex(n.intValue());
        else System.out.println("Warning: hashtable returned null!");
    }//updateParametersWall

    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel labelY;
    private javax.swing.JScrollPane scrollPaneOutput;
    public javax.swing.JTextField textFieldY1;
    public javax.swing.JTextField textFieldText;
    public javax.swing.JRadioButton radioButtonWallOuter;
    private javax.swing.JLabel labelX;
    public javax.swing.JTextField textFieldY;
    private javax.swing.JPanel settingsPanel;
    public javax.swing.JTextField textFieldX2;
    private javax.swing.JPanel positionPanel;
    public javax.swing.JCheckBox checkBoxGrid;
    private javax.swing.JComboBox comboBoxWallType;
    private javax.swing.JPanel wallsPanel;
    public javax.swing.JTextField textFieldX;
    public javax.swing.JRadioButton radioButtonWallInner;
    private javax.swing.JLabel labelX1;
    public javax.swing.JTabbedPane tabbedPaneFloors;
    private javax.swing.JTextArea textAreaOutput;
    public javax.swing.JRadioButton radioButtonWallArc;
    private javax.swing.JLabel labelLength;
    private javax.swing.JLabel labelY1;
    public javax.swing.JRadioButton radioButtonBridge;
    public javax.swing.JTextField textFieldWallLength;
    private javax.swing.JPanel menuPanel;
    private javax.swing.JLabel labelComponents;
    public javax.swing.JRadioButton radioButtonText;
    private javax.swing.JLabel labelX2;
    public javax.swing.JTextField textFieldY2;
    private javax.swing.JLabel labelWidth;
    public javax.swing.JTextField textFieldX1;
    private javax.swing.JLabel labelY2;
    private javax.swing.JPanel leftRulerPanel;
    private javax.swing.JPanel topRulerPanel;
    private javax.swing.JLabel labelActual;
    private javax.swing.JCheckBox checkBoxEdit;
    // End of variables declaration//GEN-END:variables
public javax.swing.JPanel[] editPanel={null, null, null, null, null, null, null, null, null, null};
public int activeEditPanel=0;
public int numFloors=1;

public int actWallType=Wall.WALL_ROAD;
public int actWallWidth=270;
public int actHoleHeight=2000;
public boolean actEdit=false;

public RemoveFloorPanel removeFloorPanel;
public NewFloorPanel newFloorPanel;

public String[] outerWalls = { "270", "300", "320", "600", "700", "800", "1000", "1200", "1400", "1600"};
public String[] innerWalls = { "100", "200", "270", "300", "320", "600"};
public String[] windows = { "270", "300", "320", "600", "700", "800", "1000"};

java.util.Hashtable comboBoxWallWidths = new java.util.Hashtable();

  // Dilewa
  Dilewa myDilewa = null;
  int myId  = -1;
  int wid = 501;
  public static int ID = 0;
  public static int SHAPE_DELETE =0;
  public static int SHAPE_ADD_OR_UPDATE =1;
  
  
// ----------------------------------------------------------------------------
// ---------------  Dilewa ----------------------------------------------------
// ----------------------------------------------------------------------------

public void init() {
  super.init();
}//init
 
public void start(){
  setUpDilewa();
}//start
  
public void stop() {
  myDilewa.disconnect();
}

private void setUpDilewa() {
  myDilewa = new Dilewa();

  // Vytvoreni klientu dilewa
  myDilewa.addErrorListener(this);                  // nevyuziva se
  myDilewa.addUserListener(this);                   // nevyuziva se
  myDilewa.addVariableLockListener(this);           // nevyuziva se
  myDilewa.addVariableListener(this);               // tohle se pouziva
  try  { myDilewa.connect(getCodeBase().getHost(),8698);  }
  catch ( Exception ee )
  {
   textAreaOutput.append("Problem pri pripojovani na server Dilewa!: " + ee + "\n");
//   reaguj_na_echo = false;
//   delayed_updates = false;
   return;
  }
  textAreaOutput.append("Connected to DILEWA server. \n");
  myDilewa.changeWorld(wid);
 }

public void updateWallOnDilewa(int ID, int x1, int y1, int x2, int y2, int type, int thickness, int state) {
    if(!myDilewa.isConnected()) return;
    DValue value = new DValue();
    try {
        value.out.writeInt(myId);
        value.out.writeInt(ID);
        value.out.writeInt(x1);
        value.out.writeInt(y1);
        value.out.writeInt(x2);
        value.out.writeInt(y2);
        value.out.writeInt(type);        
        value.out.writeInt(thickness);
        value.out.writeInt(state);
        DCommand cmd = new DCommand(DCommand.SEV, value, DCommand.STORE_OVERWRITE );
        // create the variable
        DCVariable variable = new DCVariable("wall"+ID);
        variable.flagDistribution=DCVariable.DISTRIBUTION_ALL;
        variable.flagEcho = DCVariable.ECHO_TRUE; //DCVariable.ECHO_FALSE;
        // zde muze byt bud STORAGE_TEMP nebo STORAGE_PERSISTENT a ani jedno nefunguje
        // rozumne
        variable.flagStorage=DCVariable.STORAGE_TEMP;
        // add the command to the variable
        variable.addCommand(cmd);
        // update the variable at the server
        myDilewa.updateVariable(variable);
    }
    catch (IOException e) {
        textAreaOutput.append("PROBLEM pri zapisu promenne wall:"+ e.getMessage()+"\n");
    }
}//updateWallOnDilewa

  // Dilewa interfaces
  // DErrorListener, DUserListener, DVariableListener, DVariableLockListener

  // ----- DVariableListener interface ---------
  public void variableUpdated(DVariableEvent e)  {
    if(e.getWorldId()!=wid) return; 
    textAreaOutput.append("\nvariableUpdated(): " + e + "\n");
    textAreaOutput.append(""+e.getVariable()+"\n");
    
    DCVariable var = e.getVariable();
    if (var.varID.startsWith("wall")) updateWallByDilewa(var);
    
    
  }//variableUpdated

  
  public void updateWallByDilewa(DCVariable var){
    java.awt.Shape shape=null;     
    for(int i=0; i<var.commands.size(); i++) {
        DCommand cmd = (DCommand)var.commands.elementAt(i);
        try {
            int sourceId = cmd.val.in.readInt();            
            if(sourceId != myId){
                int wallID = cmd.val.in.readInt();
                int x= cmd.val.in.readInt();
                int y= cmd.val.in.readInt();
                int x2= cmd.val.in.readInt();
                int y2= cmd.val.in.readInt();
                int type= cmd.val.in.readInt();
                int thickness= cmd.val.in.readInt();
                int state= cmd.val.in.readInt();
                
                if ( (shape=((EditPanel)editPanel[0]).findShape(wallID))!=null){
                    if(state==SHAPE_DELETE) ((EditPanel)editPanel[0]).shapes.remove(shape);
                    else{
                        //update existing wall
                        ((Wall)shape).x=x;
                        ((Wall)shape).y=y;
                        ((Wall)shape).x2=x2;
                        ((Wall)shape).y2=y2;
                        ((Wall)shape).type=type;
                        ((Wall)shape).thickness=thickness;
                    }//update existing
                }
                else{
                    //create new wall
                    if(state!=SHAPE_DELETE)
                        ((EditPanel)editPanel[0]).shapes.add(new Wall(wallID, x, y, x2, y2, type, thickness));
                }
                ((EditPanel)editPanel[0]).repaint();
                if(wallID>ID) ID=wallID;
                textAreaOutput.append("updateWall(" + wallID + ");\n");
            }
        }//try
        catch (IOException ex) {
            textAreaOutput.append("PROBLEM pri prijimani promenne z Dilewy: "+ ex + "\n");
        }
    }//for
  }//updateWallByDilewa
  
  public void updateStarted(DVariableEvent e)  {
    textAreaOutput.append("updateStarted(): " + e + "\n");
   }

  public void updateEnded(DVariableEvent e)  {
    textAreaOutput.append("updateEnded(): " + e + "\n");
    myId=myDilewa.getId();
    textAreaOutput.append("myId= " + myId + "\n");
   }

  // ----- DVariableLockListener interface ---------
  public void variableLocked(DVariableLockEvent e) {
    textAreaOutput.append("variableLocked(): " + e + "\n");
  }

  public void variableReleased(DVariableLockEvent e) {
    textAreaOutput.append("variableReleased(): " + e + "\n");
  }
  // ----- DErrorListener interface -------
  public void error(DErrorEvent e) {
   textAreaOutput.append("error(): " + e + "\n");
   }

  // ----- DUserListener interface ---------
  public void userEntered(DUserEvent e) {
    textAreaOutput.append("userEntered(): " + e + "\n");
   }

  public void userExited(DUserEvent e) {
    textAreaOutput.append("userExited(): " + e + "\n");
   }

}//class MapEdit