/*
 * NewFloorPanel.java
 *
 * Created on 12. 3. 2003
 */

/**
 *
 * @author  Martin Cadik - cadikm@cs.felk.cvut.cz
 * @version 1.0
 */
import java.util.Iterator;
import java.awt.*;

public class NewFloorPanel extends javax.swing.JPanel {
    /** MapEditApplet */	
    private MapEdit mapEditApplet=null;
    
    /** Creates new form NewFloorPanel */
    public NewFloorPanel(MapEdit me) {
        mapEditApplet=me;
        initComponents ();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the FormEditor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        label1 = new javax.swing.JLabel();
        checkBoxRoadWalls = new javax.swing.JCheckBox();
        checkBoxRiverWalls = new javax.swing.JCheckBox();
        checkBoxText = new javax.swing.JCheckBox();
        buttonCreateFloor = new javax.swing.JButton();

        setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        label1.setText("Do nov\u00e9 vrstvy se zkop\u00edruj\u00ed:");
        add(label1, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 10, 210, 20));

        checkBoxRoadWalls.setText("Komunikace");
        checkBoxRoadWalls.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                checkBoxRoadWallsActionPerformed(evt);
            }
        });

        add(checkBoxRoadWalls, new org.netbeans.lib.awtextra.AbsoluteConstraints(30, 30, 150, 20));

        checkBoxRiverWalls.setText("Vodn\u00ed toky");
        add(checkBoxRiverWalls, new org.netbeans.lib.awtextra.AbsoluteConstraints(30, 50, 150, 20));

        checkBoxText.setText("Text");
        checkBoxText.setToolTipText("Zkop\u00edruj\u00ed se textov\u00e9 popisky");
        add(checkBoxText, new org.netbeans.lib.awtextra.AbsoluteConstraints(30, 70, 90, 20));

        buttonCreateFloor.setText("OK");
        buttonCreateFloor.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonCreateFloorActionPerformed(evt);
            }
        });

        add(buttonCreateFloor, new org.netbeans.lib.awtextra.AbsoluteConstraints(20, 200, 80, 20));

    }//GEN-END:initComponents

    private void checkBoxRoadWallsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_checkBoxRoadWallsActionPerformed
        // Add your handling code here:
    }//GEN-LAST:event_checkBoxRoadWallsActionPerformed

  private void buttonCreateFloorActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonCreateFloorActionPerformed
    int i=mapEditApplet.numFloors;
    if(i>=MapEdit.MAX_FLOORS) return;
    mapEditApplet.editPanel[i]=new EditPanel(mapEditApplet, i);  
    
    copyFloor((EditPanel)mapEditApplet.editPanel[i-1], (EditPanel)mapEditApplet.editPanel[i], checkBoxRoadWalls.isSelected(), checkBoxRiverWalls.isSelected(), checkBoxText.isSelected() );
    
    mapEditApplet.tabbedPaneFloors.addTab(i+". vrstva", null, mapEditApplet.editPanel[i], "Zobrazen " + i + ". vrstvy");
    mapEditApplet.tabbedPaneFloors.setSelectedIndex(i+2);   
    mapEditApplet.activeEditPanel=i;
    mapEditApplet.numFloors++;    

  }//GEN-LAST:event_buttonCreateFloorActionPerformed


  private void copyFloor(EditPanel from, EditPanel to, boolean road, boolean river, boolean text){
    Shape s,t;
    Wall w;
    Iterator iter=from.shapes.iterator();
        while(iter.hasNext()){         
            t=null;
            s=(Shape)iter.next();
            if(s instanceof Wall){ 
                w=(Wall)s;
                if(  ( (w.type==Arc.OUTER_WALL_ARC) && (road)  )  || ( (w.type==Wall.WALL_RIVER) && (river) ) || ( (w.type==Wall.WALL_ROAD) && (road) ) )
                    t=(Wall)w.clone();
                
            }//wall
            
            if( (s instanceof Text) && (text) ){ 
                t=(Text)((Text)s).clone();
            }//text
            if(t!=null) to.shapes.add(t);

        }//while                    
  }//copyFloor



    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JCheckBox checkBoxText;
    private javax.swing.JCheckBox checkBoxRiverWalls;
    private javax.swing.JCheckBox checkBoxRoadWalls;
    private javax.swing.JButton buttonCreateFloor;
    private javax.swing.JLabel label1;
    // End of variables declaration//GEN-END:variables

}